﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using VaulteronDatabase;

#nullable disable

namespace VaulteronDatabase.Migrations
{
    [DbContext(typeof(VaulteronContext))]
    [Migration("20220521130245_addIsBusinessCustomer")]
    partial class addIsBusinessCustomer
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .UseCollation("utf8mb4_general_ci")
                .HasAnnotation("ProductVersion", "6.0.3")
                .HasAnnotation("Relational:MaxIdentifierLength", 64);

            MySqlModelBuilderExtensions.UseGuidCollation(modelBuilder, "utf8mb4_general_ci");

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserClaim<System.Guid>", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<string>("ClaimType")
                        .HasColumnType("longtext");

                    b.Property<string>("ClaimValue")
                        .HasColumnType("longtext");

                    b.Property<Guid>("UserId")
                        .HasColumnType("char(36)");

                    b.HasKey("Id");

                    b.HasIndex("UserId");

                    b.ToTable("AspNetUserClaims", (string)null);
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserLogin<System.Guid>", b =>
                {
                    b.Property<string>("LoginProvider")
                        .HasMaxLength(128)
                        .HasColumnType("varchar(128)");

                    b.Property<string>("ProviderKey")
                        .HasMaxLength(128)
                        .HasColumnType("varchar(128)");

                    b.Property<string>("ProviderDisplayName")
                        .HasColumnType("longtext");

                    b.Property<Guid>("UserId")
                        .HasColumnType("char(36)");

                    b.HasKey("LoginProvider", "ProviderKey");

                    b.HasIndex("UserId");

                    b.ToTable("AspNetUserLogins", (string)null);
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserToken<System.Guid>", b =>
                {
                    b.Property<Guid>("UserId")
                        .HasColumnType("char(36)");

                    b.Property<string>("LoginProvider")
                        .HasMaxLength(128)
                        .HasColumnType("varchar(128)");

                    b.Property<string>("Name")
                        .HasMaxLength(128)
                        .HasColumnType("varchar(128)");

                    b.Property<string>("Value")
                        .HasColumnType("longtext");

                    b.HasKey("UserId", "LoginProvider", "Name");

                    b.ToTable("AspNetUserTokens", (string)null);
                });

            modelBuilder.Entity("VaulteronDatabase.Models.AccountPassword", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<DateTime?>("ArchivedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("Login")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<Guid>("MandatorId")
                        .HasColumnType("char(36)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<string>("Notes")
                        .HasColumnType("longtext");

                    b.Property<Guid>("OwnerId")
                        .HasColumnType("char(36)");

                    b.Property<int>("SecurityRating")
                        .HasColumnType("int");

                    b.Property<DateTime>("UpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("WebsiteURL")
                        .HasColumnType("longtext");

                    b.HasKey("Id");

                    b.HasIndex("MandatorId");

                    b.HasIndex("OwnerId");

                    b.ToTable("AccountPasswords");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.AccountPasswordAccessLog", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<Guid>("AccountPasswordId")
                        .HasColumnType("char(36)");

                    b.Property<int>("Agent")
                        .HasColumnType("int");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<DateTime>("UpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.HasKey("Id");

                    b.HasIndex("AccountPasswordId");

                    b.ToTable("AccountPasswordAccessLogs");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.AccountPasswordTag", b =>
                {
                    b.Property<Guid>("TagId")
                        .HasColumnType("char(36)");

                    b.Property<Guid>("PasswordId")
                        .HasColumnType("char(36)");

                    b.HasKey("TagId", "PasswordId");

                    b.HasIndex("PasswordId");

                    b.ToTable("AccountPasswordTags");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.AccountTag", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<string>("Color")
                        .HasColumnType("longtext");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<Guid>("OwnerId")
                        .HasColumnType("char(36)");

                    b.Property<DateTime>("UpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.HasKey("Id");

                    b.HasIndex("OwnerId");

                    b.ToTable("AccountTags");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.ChangeLog", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<Guid>("CreatedById")
                        .HasColumnType("char(36)");

                    b.Property<Guid>("EntityId")
                        .HasColumnType("char(36)");

                    b.Property<string>("EntityName")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<string>("NewValue")
                        .HasColumnType("longtext");

                    b.Property<string>("OldValue")
                        .HasColumnType("longtext");

                    b.Property<string>("PropertyName")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.HasKey("Id");

                    b.HasIndex("CreatedById");

                    b.ToTable("ChangeLogs");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.EncryptedAccountPassword", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<Guid>("AccountPasswordId")
                        .HasColumnType("char(36)");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<Guid?>("CreatedById")
                        .HasColumnType("char(36)");

                    b.Property<string>("EncryptedPasswordString")
                        .HasColumnType("longtext");

                    b.Property<Guid>("KeyPairId")
                        .HasColumnType("char(36)");

                    b.Property<DateTime>("UpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.HasKey("Id");

                    b.HasIndex("AccountPasswordId");

                    b.HasIndex("CreatedById");

                    b.HasIndex("KeyPairId");

                    b.ToTable("EncryptedAccountPasswords");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.EncryptedSharedPassword", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<Guid?>("CreatedById")
                        .HasColumnType("char(36)");

                    b.Property<string>("EncryptedPasswordString")
                        .HasColumnType("longtext");

                    b.Property<Guid>("KeyPairId")
                        .HasColumnType("char(36)");

                    b.Property<Guid>("SharedPasswordId")
                        .HasColumnType("char(36)");

                    b.Property<DateTime>("UpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.HasKey("Id");

                    b.HasIndex("CreatedById");

                    b.HasIndex("KeyPairId");

                    b.HasIndex("SharedPasswordId");

                    b.ToTable("EncryptedSharedPasswords");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.Group", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<DateTime?>("ArchivedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<Guid>("MandatorId")
                        .HasColumnType("char(36)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<Guid?>("ParentGroupId")
                        .HasColumnType("char(36)");

                    b.Property<DateTime>("UpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.HasKey("Id");

                    b.HasIndex("MandatorId");

                    b.HasIndex("ParentGroupId");

                    b.ToTable("Groups");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.KeyPair", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("EncryptedPrivateKey")
                        .HasColumnType("longtext");

                    b.Property<string>("PreviousPasswordHashEncryptedWithPublicKey")
                        .HasColumnType("longtext");

                    b.Property<string>("PublicKeyString")
                        .HasColumnType("longtext");

                    b.Property<DateTime>("UpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<Guid>("UserId")
                        .HasColumnType("char(36)");

                    b.HasKey("Id");

                    b.HasIndex("UserId");

                    b.ToTable("KeyPairs");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.Mandator", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("InternalDescription")
                        .HasColumnType("longtext");

                    b.Property<bool>("IsBusinessCustomer")
                        .HasColumnType("tinyint(1)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<string>("PaymentProviderId")
                        .HasColumnType("longtext");

                    b.Property<int>("SubscriptionStatus")
                        .HasColumnType("int");

                    b.Property<long>("SubscriptionUserLimit")
                        .HasColumnType("bigint");

                    b.Property<bool>("TwoFactorRequired")
                        .HasColumnType("tinyint(1)");

                    b.Property<DateTime>("UpdatedAt")
                        .ValueGeneratedOnUpdateSometimes()
                        .HasColumnType("datetime(6)");

                    b.HasKey("Id");

                    b.ToTable("Mandators");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.SharedPassword", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<DateTime?>("ArchivedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<Guid?>("CreatedById")
                        .HasColumnType("char(36)");

                    b.Property<Guid?>("GroupId")
                        .HasColumnType("char(36)");

                    b.Property<bool>("IsSavedAsOfflinePassword")
                        .HasColumnType("tinyint(1)");

                    b.Property<string>("Login")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<Guid>("MandatorId")
                        .HasColumnType("char(36)");

                    b.Property<string>("ModifyLock")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<string>("Notes")
                        .HasColumnType("longtext");

                    b.Property<int>("SecurityRating")
                        .HasColumnType("int");

                    b.Property<DateTime>("UpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("WebsiteURL")
                        .HasColumnType("longtext");

                    b.HasKey("Id");

                    b.HasIndex("CreatedById");

                    b.HasIndex("GroupId");

                    b.HasIndex("MandatorId");

                    b.ToTable("SharedPasswords");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.SharedPasswordAccessLog", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<int>("Agent")
                        .HasColumnType("int");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<Guid>("SharedPasswordId")
                        .HasColumnType("char(36)");

                    b.Property<DateTime>("UpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<Guid>("UserId")
                        .HasColumnType("char(36)");

                    b.HasKey("Id");

                    b.HasIndex("SharedPasswordId");

                    b.HasIndex("UserId");

                    b.HasIndex(new[] { "CreatedAt" }, "OrderByOptimisation_CreatedAt");

                    b.ToTable("SharedPasswordAccessLogs");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.SharedPasswordTag", b =>
                {
                    b.Property<Guid>("TagId")
                        .HasColumnType("char(36)");

                    b.Property<Guid>("PasswordId")
                        .HasColumnType("char(36)");

                    b.HasKey("TagId", "PasswordId");

                    b.HasIndex("PasswordId");

                    b.ToTable("SharedPasswordTags");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.SharedTag", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<string>("Color")
                        .HasColumnType("longtext");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<Guid>("GroupId")
                        .HasColumnType("char(36)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<DateTime>("UpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.HasKey("Id");

                    b.HasIndex("GroupId");

                    b.ToTable("SharedTags");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.SyncSettings", b =>
                {
                    b.Property<Guid>("Id")
                        .HasColumnType("char(36)");

                    b.Property<string>("AdminGroupCN")
                        .IsRequired()
                        .HasColumnType("longtext")
                        .HasColumnName("SyncAdminGroupCN");

                    b.Property<string>("BaseOU")
                        .IsRequired()
                        .HasColumnType("longtext")
                        .HasColumnName("SyncBaseOU");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<DateTime?>("DueAt")
                        .HasColumnType("datetime(6)")
                        .HasColumnName("SyncDueAt");

                    b.Property<TimeSpan?>("Interval")
                        .HasColumnType("time(6)")
                        .HasColumnName("SyncInterval");

                    b.Property<string>("Location")
                        .IsRequired()
                        .HasColumnType("longtext")
                        .HasColumnName("SyncLocation");

                    b.Property<byte[]>("SSLCertificate")
                        .IsRequired()
                        .HasColumnType("longblob")
                        .HasColumnName("SyncSSLCertificate");

                    b.Property<int>("SyncType")
                        .HasColumnType("int");

                    b.Property<DateTime>("UpdatedAt")
                        .ValueGeneratedOnUpdateSometimes()
                        .HasColumnType("datetime(6)");

                    b.Property<bool>("UseSSLPort")
                        .HasColumnType("tinyint(1)")
                        .HasColumnName("SyncUseSSLPort");

                    b.Property<string>("UserName")
                        .IsRequired()
                        .HasColumnType("longtext")
                        .HasColumnName("SyncUserName");

                    b.Property<string>("UserPassword")
                        .IsRequired()
                        .HasColumnType("longtext")
                        .HasColumnName("SyncUserPassword");

                    b.HasKey("Id");

                    b.ToTable("Mandators");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.User", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<int>("AccessFailedCount")
                        .HasColumnType("int");

                    b.Property<bool>("Admin")
                        .HasColumnType("tinyint(1)");

                    b.Property<DateTime?>("ArchivedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("ConcurrencyStamp")
                        .IsConcurrencyToken()
                        .HasColumnType("longtext");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("Email")
                        .HasMaxLength(256)
                        .HasColumnType("varchar(256)");

                    b.Property<bool>("EmailConfirmed")
                        .HasColumnType("tinyint(1)");

                    b.Property<string>("Firstname")
                        .HasColumnType("longtext");

                    b.Property<Guid?>("ForeignObjectId")
                        .HasColumnType("char(36)");

                    b.Property<string>("Lastname")
                        .HasColumnType("longtext");

                    b.Property<bool>("LockoutEnabled")
                        .HasColumnType("tinyint(1)");

                    b.Property<DateTimeOffset?>("LockoutEnd")
                        .HasColumnType("datetime(6)");

                    b.Property<Guid>("MandatorId")
                        .HasColumnType("char(36)");

                    b.Property<string>("NormalizedEmail")
                        .HasMaxLength(256)
                        .HasColumnType("varchar(256)");

                    b.Property<string>("NormalizedUserName")
                        .HasMaxLength(256)
                        .HasColumnType("varchar(256)");

                    b.Property<DateTime>("PasswordChangedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("PasswordHash")
                        .HasColumnType("longtext");

                    b.Property<string>("PhoneNumber")
                        .HasColumnType("longtext");

                    b.Property<bool>("PhoneNumberConfirmed")
                        .HasColumnType("tinyint(1)");

                    b.Property<string>("SecurityStamp")
                        .HasColumnType("longtext");

                    b.Property<int>("Sex")
                        .HasColumnType("int");

                    b.Property<int>("TwoFATypesEnabled")
                        .HasColumnType("int");

                    b.Property<bool>("TwoFactorEnabled")
                        .HasColumnType("tinyint(1)");

                    b.Property<DateTime>("UpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("UserName")
                        .HasMaxLength(256)
                        .HasColumnType("varchar(256)");

                    b.HasKey("Id");

                    b.HasIndex("MandatorId");

                    b.HasIndex("NormalizedEmail")
                        .HasDatabaseName("EmailIndex");

                    b.HasIndex("NormalizedUserName")
                        .IsUnique()
                        .HasDatabaseName("UserNameIndex");

                    b.ToTable("AspNetUsers", (string)null);
                });

            modelBuilder.Entity("VaulteronDatabase.Models.UserGroup", b =>
                {
                    b.Property<Guid>("UserId")
                        .HasColumnType("char(36)");

                    b.Property<Guid>("GroupId")
                        .HasColumnType("char(36)");

                    b.Property<int>("GroupRole")
                        .HasColumnType("int");

                    b.HasKey("UserId", "GroupId");

                    b.HasIndex("GroupId");

                    b.ToTable("UserGroups");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.WebauthnPublicKeys", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<uint>("Counter")
                        .HasColumnType("int unsigned");

                    b.Property<byte[]>("CredentialId")
                        .HasColumnType("longblob");

                    b.Property<byte[]>("PublicKey")
                        .HasColumnType("longblob");

                    b.Property<Guid>("UserId")
                        .HasColumnType("char(36)");

                    b.HasKey("Id");

                    b.HasIndex("UserId");

                    b.ToTable("WebauthnPublicKeys");
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserClaim<System.Guid>", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.User", null)
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserLogin<System.Guid>", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.User", null)
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserToken<System.Guid>", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.User", null)
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("VaulteronDatabase.Models.AccountPassword", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.Mandator", "Mandator")
                        .WithMany("AccountPasswords")
                        .HasForeignKey("MandatorId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.HasOne("VaulteronDatabase.Models.User", "Owner")
                        .WithMany("AccountPasswords")
                        .HasForeignKey("OwnerId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("Mandator");

                    b.Navigation("Owner");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.AccountPasswordAccessLog", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.AccountPassword", "AccountPassword")
                        .WithMany("AccountPasswordAccessLogs")
                        .HasForeignKey("AccountPasswordId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("AccountPassword");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.AccountPasswordTag", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.AccountPassword", "Password")
                        .WithMany("AccountPasswordTags")
                        .HasForeignKey("PasswordId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("VaulteronDatabase.Models.AccountTag", "Tag")
                        .WithMany("AccountPasswordTags")
                        .HasForeignKey("TagId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Password");

                    b.Navigation("Tag");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.AccountTag", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.User", "Owner")
                        .WithMany("Tags")
                        .HasForeignKey("OwnerId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("Owner");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.ChangeLog", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.User", "CreatedBy")
                        .WithMany("ChangeLogs")
                        .HasForeignKey("CreatedById")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("CreatedBy");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.EncryptedAccountPassword", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.AccountPassword", "AccountPassword")
                        .WithMany("EncryptedAccountPasswords")
                        .HasForeignKey("AccountPasswordId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("VaulteronDatabase.Models.User", "CreatedBy")
                        .WithMany()
                        .HasForeignKey("CreatedById");

                    b.HasOne("VaulteronDatabase.Models.KeyPair", "KeyPair")
                        .WithMany("EncryptedAccountPasswords")
                        .HasForeignKey("KeyPairId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("AccountPassword");

                    b.Navigation("CreatedBy");

                    b.Navigation("KeyPair");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.EncryptedSharedPassword", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.User", "CreatedBy")
                        .WithMany()
                        .HasForeignKey("CreatedById");

                    b.HasOne("VaulteronDatabase.Models.KeyPair", "KeyPair")
                        .WithMany("EncryptedSharedPasswords")
                        .HasForeignKey("KeyPairId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("VaulteronDatabase.Models.SharedPassword", "SharedPassword")
                        .WithMany("EncryptedSharedPasswords")
                        .HasForeignKey("SharedPasswordId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("CreatedBy");

                    b.Navigation("KeyPair");

                    b.Navigation("SharedPassword");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.Group", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.Mandator", "Mandator")
                        .WithMany("Groups")
                        .HasForeignKey("MandatorId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("VaulteronDatabase.Models.Group", "ParentGroup")
                        .WithMany("ChildGroups")
                        .HasForeignKey("ParentGroupId")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.Navigation("Mandator");

                    b.Navigation("ParentGroup");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.KeyPair", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.User", "User")
                        .WithMany("KeyPairs")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("User");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.SharedPassword", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.User", "CreatedBy")
                        .WithMany()
                        .HasForeignKey("CreatedById");

                    b.HasOne("VaulteronDatabase.Models.Group", "Group")
                        .WithMany("SharedPasswords")
                        .HasForeignKey("GroupId");

                    b.HasOne("VaulteronDatabase.Models.Mandator", "Mandator")
                        .WithMany("SharedPasswords")
                        .HasForeignKey("MandatorId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("CreatedBy");

                    b.Navigation("Group");

                    b.Navigation("Mandator");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.SharedPasswordAccessLog", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.SharedPassword", "SharedPassword")
                        .WithMany("AccessLogs")
                        .HasForeignKey("SharedPasswordId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("VaulteronDatabase.Models.User", "User")
                        .WithMany("AccessLogs")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("SharedPassword");

                    b.Navigation("User");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.SharedPasswordTag", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.SharedPassword", "Password")
                        .WithMany("SharedPasswordTags")
                        .HasForeignKey("PasswordId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("VaulteronDatabase.Models.SharedTag", "Tag")
                        .WithMany("SharedPasswordTags")
                        .HasForeignKey("TagId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Password");

                    b.Navigation("Tag");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.SharedTag", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.Group", "Group")
                        .WithMany("Tags")
                        .HasForeignKey("GroupId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("Group");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.SyncSettings", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.Mandator", "Mandator")
                        .WithOne("SyncSettings")
                        .HasForeignKey("VaulteronDatabase.Models.SyncSettings", "Id")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Mandator");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.User", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.Mandator", "Mandator")
                        .WithMany("Users")
                        .HasForeignKey("MandatorId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Mandator");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.UserGroup", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.Group", "Group")
                        .WithMany("UserGroups")
                        .HasForeignKey("GroupId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("VaulteronDatabase.Models.User", "User")
                        .WithMany("UserGroups")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Group");

                    b.Navigation("User");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.WebauthnPublicKeys", b =>
                {
                    b.HasOne("VaulteronDatabase.Models.User", "User")
                        .WithMany("WebautnCredentials")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("User");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.AccountPassword", b =>
                {
                    b.Navigation("AccountPasswordAccessLogs");

                    b.Navigation("AccountPasswordTags");

                    b.Navigation("EncryptedAccountPasswords");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.AccountTag", b =>
                {
                    b.Navigation("AccountPasswordTags");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.Group", b =>
                {
                    b.Navigation("ChildGroups");

                    b.Navigation("SharedPasswords");

                    b.Navigation("Tags");

                    b.Navigation("UserGroups");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.KeyPair", b =>
                {
                    b.Navigation("EncryptedAccountPasswords");

                    b.Navigation("EncryptedSharedPasswords");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.Mandator", b =>
                {
                    b.Navigation("AccountPasswords");

                    b.Navigation("Groups");

                    b.Navigation("SharedPasswords");

                    b.Navigation("SyncSettings");

                    b.Navigation("Users");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.SharedPassword", b =>
                {
                    b.Navigation("AccessLogs");

                    b.Navigation("EncryptedSharedPasswords");

                    b.Navigation("SharedPasswordTags");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.SharedTag", b =>
                {
                    b.Navigation("SharedPasswordTags");
                });

            modelBuilder.Entity("VaulteronDatabase.Models.User", b =>
                {
                    b.Navigation("AccessLogs");

                    b.Navigation("AccountPasswords");

                    b.Navigation("ChangeLogs");

                    b.Navigation("KeyPairs");

                    b.Navigation("Tags");

                    b.Navigation("UserGroups");

                    b.Navigation("WebautnCredentials");
                });
#pragma warning restore 612, 618
        }
    }
}
